import * as i0 from '@angular/core';
import { Injectable, Pipe, NgModule } from '@angular/core';

const NGX_NUMBERS_LOCALES = new Map()
    .set("cs_CZ", {
    thousandSeparator: " ",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "Kč"
})
    .set("da_DK", {
    thousandSeparator: ".",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "kr."
})
    .set("de_DE", {
    thousandSeparator: ".",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "€"
})
    .set("de_AT", {
    thousandSeparator: " ",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "€"
})
    .set("de_CH", {
    thousandSeparator: "’",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "CHF"
})
    .set("de_LU", {
    thousandSeparator: ".",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "€"
})
    .set("el_GR", {
    thousandSeparator: ".",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "€"
})
    .set("en_AU", {
    thousandSeparator: ",",
    decimalSeparator: ".",
    whitespaceBeforeCurrency: true,
    currency: "$"
})
    .set("en_CA", {
    thousandSeparator: " ",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "CAD"
})
    .set("en_GB", {
    thousandSeparator: ",",
    decimalSeparator: ".",
    whitespaceBeforeCurrency: true,
    currency: "£"
})
    .set("en_HK", {
    thousandSeparator: ",",
    decimalSeparator: ".",
    whitespaceBeforeCurrency: false,
    currency: "HK$"
})
    .set("en_IE", {
    thousandSeparator: ",",
    decimalSeparator: ".",
    whitespaceBeforeCurrency: true,
    currency: "€"
})
    .set("en_IN", {
    thousandSeparator: ",",
    decimalSeparator: ".",
    whitespaceBeforeCurrency: false,
    currency: "₹"
})
    .set("en_MY", {
    thousandSeparator: ",",
    decimalSeparator: ".",
    whitespaceBeforeCurrency: false,
    currency: "MYR"
})
    .set("en_NZ", {
    thousandSeparator: ",",
    decimalSeparator: ".",
    whitespaceBeforeCurrency: true,
    currency: "$"
})
    .set("en_TH", {
    thousandSeparator: ",",
    decimalSeparator: ".",
    whitespaceBeforeCurrency: true,
    currency: "฿"
})
    .set("en_US", {
    thousandSeparator: ",",
    decimalSeparator: ".",
    whitespaceBeforeCurrency: true,
    currency: "$"
})
    .set("en_ZA", {
    thousandSeparator: ",",
    decimalSeparator: ".",
    whitespaceBeforeCurrency: false,
    currency: "ZAR"
})
    .set("es_AR", {
    thousandSeparator: ".",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "$"
})
    .set("es_CO", {
    thousandSeparator: ".",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "$"
})
    .set("es_ES", {
    thousandSeparator: ".",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "€"
})
    .set("fi_FI", {
    thousandSeparator: " ",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "€"
})
    .set("fr_BE", {
    thousandSeparator: " ",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "€"
})
    .set("fr_CA", {
    thousandSeparator: " ",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "CAD"
})
    .set("fr_CH", {
    thousandSeparator: " ",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "CHF"
})
    .set("fr_FR", {
    thousandSeparator: " ",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "€"
})
    .set("fr_LU", {
    thousandSeparator: ".",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "€"
})
    .set("ga_IE", {
    thousandSeparator: ",",
    decimalSeparator: ".",
    whitespaceBeforeCurrency: true,
    currency: "€"
})
    .set("hu_HU", {
    thousandSeparator: " ",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "Ft."
})
    .set("is_IS", {
    thousandSeparator: ".",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "ISK"
})
    .set("it_CH", {
    thousandSeparator: "’",
    decimalSeparator: ".",
    whitespaceBeforeCurrency: true,
    currency: "CHF"
})
    .set("it_IT", {
    thousandSeparator: ".",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "€"
})
    .set("ja_JP", {
    thousandSeparator: ",",
    decimalSeparator: ".",
    whitespaceBeforeCurrency: true,
    currency: "￥"
})
    .set("ko_KR", {
    thousandSeparator: ",",
    decimalSeparator: ".",
    whitespaceBeforeCurrency: true,
    currency: "₩"
})
    .set("nl_BE", {
    thousandSeparator: ".",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "€"
})
    .set("nl_NL", {
    thousandSeparator: ".",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "€"
})
    .set("no_NO", {
    thousandSeparator: " ",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "kr"
})
    .set("pl_PL", {
    thousandSeparator: " ",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "zł"
})
    .set("pt_PT", {
    thousandSeparator: ".",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "€"
})
    .set("pt_BR", {
    thousandSeparator: " ",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "R$"
})
    .set("ro_RO", {
    thousandSeparator: ".",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "RON"
})
    .set("ru_RU", {
    thousandSeparator: " ",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "RUB"
})
    .set("sk_SK", {
    thousandSeparator: " ",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "€"
})
    .set("sv_SE", {
    thousandSeparator: " ",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "kr"
})
    .set("th_TH", {
    thousandSeparator: ",",
    decimalSeparator: ".",
    whitespaceBeforeCurrency: true,
    currency: "฿"
})
    .set("tr_TR", {
    thousandSeparator: ".",
    decimalSeparator: ",",
    whitespaceBeforeCurrency: true,
    currency: "₺"
})
    .set("zh_CN", {
    thousandSeparator: " ",
    decimalSeparator: ".",
    whitespaceBeforeCurrency: true,
    currency: "CNY"
})
    .set("zh_HK", {
    thousandSeparator: ",",
    decimalSeparator: ".",
    whitespaceBeforeCurrency: false,
    currency: "HK$"
})
    .set("zh_TW", {
    thousandSeparator: " ",
    decimalSeparator: ".",
    whitespaceBeforeCurrency: true,
    currency: "TWS"
});

class NgxLocalizedNumbersService {
    constructor() {
        this.DEFAULT_LOCALE = "en_GB";
        this.definedLocales = new Map();
        this.definedLocales = NGX_NUMBERS_LOCALES;
    }
    setLocale(locale) {
        if (!this.definedLocales.get(locale)) {
            console.warn("ngx-localized-numbers: locale '" + locale + "' does not exist");
        }
        this.locale = locale;
    }
    getLocale() {
        if (!this.locale) {
            console.warn("ngx-localized-numbers: no locale was defined, return default");
            return this.DEFAULT_LOCALE;
        }
        return this.locale;
    }
    addLocale(locale, config) {
        this.definedLocales.set(locale, config);
    }
    getCurrentLocaleDefinition() {
        return this.definedLocales.get(this.getLocale());
    }
    formatNumber(value, decimals) {
        const strValue = "" + this.round(value, decimals);
        const numberParts = strValue.split(".");
        let beforeComma = numberParts[0];
        let afterComma = numberParts.length > 1 ? "." + numberParts[1] : "";
        const rgx = /(\d+)(\d{3})/;
        while (rgx.test(beforeComma)) {
            beforeComma = beforeComma.replace(rgx, "$1" + this.getCurrentLocaleDefinition().thousandSeparator + "$2");
        }
        let decimalSeparator = "";
        if (decimals > 0) {
            decimalSeparator = this.getCurrentLocaleDefinition().decimalSeparator;
        }
        if (afterComma.indexOf(".") > -1) {
            afterComma = afterComma.replace(".", "");
        }
        while (afterComma.length < decimals) {
            afterComma += "0";
        }
        return beforeComma + decimalSeparator + afterComma;
    }
    formatCurrency(value) {
        let output = value;
        if (this.getCurrentLocaleDefinition().whitespaceBeforeCurrency) {
            output += " ";
        }
        output += this.getCurrentLocaleDefinition().currency;
        return output;
    }
    round(value, prec) {
        if (typeof prec === "undefined" || +prec === 0) {
            return Math.round(value);
        }
        value = +value;
        prec = +prec;
        if (isNaN(value) || !(typeof prec === "number" && prec % 1 === 0)) {
            return NaN;
        }
        let shiftValues = value.toString().split("e");
        value = Math.round(+(shiftValues[0] + "e" + (shiftValues[1] ? +shiftValues[1] + prec : prec)));
        shiftValues = value.toString().split("e");
        return +(shiftValues[0] + "e" + (shiftValues[1] ? +shiftValues[1] - prec : -prec));
    }
}
NgxLocalizedNumbersService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.6", ngImport: i0, type: NgxLocalizedNumbersService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
NgxLocalizedNumbersService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.2.6", ngImport: i0, type: NgxLocalizedNumbersService });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.6", ngImport: i0, type: NgxLocalizedNumbersService, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return []; } });

class LocalizationFormatCurrencyPipe {
    constructor(numberService) {
        this.numberService = numberService;
    }
    transform(value, _args) {
        return this.numberService.formatCurrency(value);
    }
}
LocalizationFormatCurrencyPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.6", ngImport: i0, type: LocalizationFormatCurrencyPipe, deps: [{ token: NgxLocalizedNumbersService }], target: i0.ɵɵFactoryTarget.Pipe });
LocalizationFormatCurrencyPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.2.6", ngImport: i0, type: LocalizationFormatCurrencyPipe, name: "formatCurrency" });
LocalizationFormatCurrencyPipe.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "13.2.6", ngImport: i0, type: LocalizationFormatCurrencyPipe });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.6", ngImport: i0, type: LocalizationFormatCurrencyPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: "formatCurrency"
                }]
        }, {
            type: Injectable
        }], ctorParameters: function () { return [{ type: NgxLocalizedNumbersService }]; } });

class LocalizationFormatNumberPipe {
    constructor(numberService) {
        this.numberService = numberService;
    }
    transform(value, decimals) {
        return this.numberService.formatNumber(value, decimals);
    }
}
LocalizationFormatNumberPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.6", ngImport: i0, type: LocalizationFormatNumberPipe, deps: [{ token: NgxLocalizedNumbersService }], target: i0.ɵɵFactoryTarget.Pipe });
LocalizationFormatNumberPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "13.2.6", ngImport: i0, type: LocalizationFormatNumberPipe, name: "formatNumber" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.6", ngImport: i0, type: LocalizationFormatNumberPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: "formatNumber"
                }]
        }], ctorParameters: function () { return [{ type: NgxLocalizedNumbersService }]; } });

const PIPE_DECLARATIONS = [LocalizationFormatCurrencyPipe, LocalizationFormatNumberPipe];
class NgxLocalizedNumbers {
    static forRoot() {
        return {
            ngModule: NgxLocalizedNumbers,
            providers: [NgxLocalizedNumbersService]
        };
    }
}
NgxLocalizedNumbers.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "13.2.6", ngImport: i0, type: NgxLocalizedNumbers, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgxLocalizedNumbers.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "13.2.6", ngImport: i0, type: NgxLocalizedNumbers, declarations: [LocalizationFormatCurrencyPipe, LocalizationFormatNumberPipe], exports: [LocalizationFormatCurrencyPipe, LocalizationFormatNumberPipe] });
NgxLocalizedNumbers.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "13.2.6", ngImport: i0, type: NgxLocalizedNumbers, providers: [], imports: [[]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "13.2.6", ngImport: i0, type: NgxLocalizedNumbers, decorators: [{
            type: NgModule,
            args: [{
                    imports: [],
                    exports: [PIPE_DECLARATIONS],
                    declarations: [PIPE_DECLARATIONS],
                    providers: []
                }]
        }] });

export { LocalizationFormatCurrencyPipe, LocalizationFormatNumberPipe, NgxLocalizedNumbers, NgxLocalizedNumbersService };
//# sourceMappingURL=ngx-localized-numbers.mjs.map
